module Paths_aws_elastic_transcoder (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
catchIO = Exception.catch


version :: Version
version = Version {versionBranch = [0,0,0,1], versionTags = []}
bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/chris/.cabal/bin"
libdir     = "/home/chris/.hubrc/heap/63/aws-elastic-transcoder-0.0.0.1/ghc-7.4.2"
datadir    = "/home/chris/.cabal/share/aws-elastic-transcoder-0.0.0.1"
libexecdir = "/home/chris/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catchIO (getEnv "aws_elastic_transcoder_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "aws_elastic_transcoder_libdir") (\_ -> return libdir)
getDataDir = catchIO (getEnv "aws_elastic_transcoder_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "aws_elastic_transcoder_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
